comonad-4.2.7.2: Comonads

Copyright | (C) 2008-2015 Edward Kmett
License | BSD-style (see the file LICENSE)
Maintainer | Edward Kmett <ekmett@gmail.com>
Stability | experimental
Portability | non-portable (fundeps, MPTCs)
Safe Haskell | Safe
Language | Haskell2010

Control.Comonad.Env.Class

Description

# Documentation

class Comonad w => ComonadEnv e w | w -> e where Source

Methods

ask :: w a -> e Source

Instances

ComonadEnv e w => ComonadEnv e (IdentityT w) Source |
ComonadEnv e (Arg e) Source |
ComonadEnv e ((,) e) Source |
(ComonadEnv e w, Monoid m) => ComonadEnv e (TracedT m w) Source |
ComonadEnv e w => ComonadEnv e (StoreT t w) Source |
Comonad w => ComonadEnv e (EnvT e w) Source |

asks :: ComonadEnv e w => (e -> e') -> w a -> e' Source